/[gentoo-x86]/x11-base/xorg-server/xorg-server-1.7.7-r1.ebuild
Gentoo

Contents of /x11-base/xorg-server/xorg-server-1.7.7-r1.ebuild

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.4 - (show annotations) (download)
Fri Aug 6 18:29:59 2010 UTC (4 years ago) by hwoarang
Branch: MAIN
Changes since 1.3: +2 -2 lines
Stable on amd64 wrt bug #330593
(Portage version: 2.2_rc67/cvs/Linux x86_64)

1 # Copyright 1999-2010 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/x11-base/xorg-server/xorg-server-1.7.7-r1.ebuild,v 1.3 2010/08/06 11:50:01 fauli Exp $
4
5 EAPI="2"
6
7 # Must be before x-modular eclass is inherited
8 SNAPSHOT="yes"
9
10 inherit x-modular multilib versionator
11
12 EGIT_REPO_URI="git://anongit.freedesktop.org/git/xorg/xserver"
13
14 OPENGL_DIR="xorg-x11"
15
16 SRC_URI="${SRC_URI}
17 http://dev.gentoo.org/~scarabeus/${P}-patches-01.tar.bz2
18 "
19 DESCRIPTION="X.Org X servers"
20 KEYWORDS="~alpha amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sh ~sparc x86 ~x86-fbsd"
21
22 IUSE_SERVERS="dmx kdrive xorg"
23 IUSE="${IUSE_SERVERS} tslib hal ipv6 minimal nptl sdl"
24 RDEPEND="hal? ( sys-apps/hal )
25 tslib? ( >=x11-libs/tslib-1.0 x11-proto/xcalibrateproto )
26 dev-libs/openssl
27 >=x11-libs/libXfont-1.3.3
28 >=x11-libs/xtrans-1.2.2
29 >=x11-libs/libXau-1.0.4
30 >=x11-libs/libxkbfile-1.0.4
31 >=x11-libs/libXdmcp-1.0.2
32 >=x11-libs/libpciaccess-0.10.3
33 >=x11-libs/pixman-0.15.20
34 media-libs/freetype
35 >=x11-misc/xbitmaps-1.0.1
36 >=x11-misc/xkeyboard-config-1.4
37 x11-apps/xkbcomp
38 >=x11-apps/iceauth-1.0.2
39 >=x11-apps/rgb-1.0.3
40 >=x11-apps/xauth-1.0.3
41 <=x11-apps/xinit-1.2.1
42 >=app-admin/eselect-opengl-1.0.8
43 dmx? (
44 x11-libs/libXt
45 >=x11-libs/libdmx-1.0.99.1
46 >=x11-libs/libX11-1.1.5
47 >=x11-libs/libXaw-1.0.4
48 >=x11-libs/libXext-1.0.5
49 >=x11-libs/libXfixes-4.0.3
50 >=x11-libs/libXi-1.2.99.1
51 >=x11-libs/libXmu-1.0.3
52 >=x11-libs/libXtst-1.0.3
53 )
54 !minimal? (
55 >=x11-libs/libX11-1.1.5
56 >=x11-libs/libXext-1.0.5
57 >=x11-libs/libXres-1.0.3
58 >=media-libs/mesa-7.4[nptl=]
59 )
60 >=x11-libs/libxkbui-1.0.2
61 kdrive? (
62 >=x11-libs/libXext-1.0.5
63 sdl? ( media-libs/libsdl ) )"
64 # Xres is dmx-dependent
65 # Xaw is dmx-dependent
66 # Xpm is dmx-dependent, pulls in Xt
67 # xkbcomp is launched at startup but not checked by ./configure
68
69 ## Deps that don't have a version in configure.ac but do here:
70 # x11-proto/resourceproto
71 # x11-proto/fontsproto
72 # x11-libs/libXau
73 # x11-libs/libXfont
74 # x11-libs/libXdmcp
75 # x11-libs/libXext
76 # x11-libs/libX11
77 # x11-libs/libXrender
78 # x11-libs/libXmu
79 # x11-libs/libXfixes
80 # x11-libs/libXtst
81 # x11-proto/xineramaproto
82 # x11-proto/dmxproto
83 ## Deps that are larger here than in configure.ac
84 # x11-libs/libpciaccess-0.8.0
85 #
86
87 DEPEND="${RDEPEND}
88 !!net-dialup/dtrace
89 sys-devel/flex
90 >=x11-proto/randrproto-1.2.99.3
91 >=x11-proto/renderproto-0.11
92 >=x11-proto/fixesproto-4.1
93 >=x11-proto/damageproto-1.1
94 >=x11-proto/xextproto-7.0.99.3
95 >=x11-proto/xproto-7.0.13
96 >=x11-proto/xf86dgaproto-2.0.99.1
97 >=x11-proto/xf86rushproto-1.1.2
98 >=x11-proto/xf86vidmodeproto-2.2.99.1
99 >=x11-proto/compositeproto-0.4
100 >=x11-proto/recordproto-1.13.99.1
101 >=x11-proto/resourceproto-1.0.2
102 >=x11-proto/videoproto-2.2.2
103 >=x11-proto/scrnsaverproto-1.1
104 >=x11-proto/trapproto-3.4.3
105 >=x11-proto/xineramaproto-1.1.3
106 >=x11-proto/fontsproto-2.0.2
107 >=x11-proto/kbproto-1.0.3
108 >=x11-proto/inputproto-1.9.99.902
109 >=x11-proto/bigreqsproto-1.1.0
110 >=x11-proto/xcmiscproto-1.2.0
111 >=x11-proto/glproto-1.4.9
112 dmx? ( >=x11-proto/dmxproto-2.2.99.1 )
113 !minimal? (
114 >=x11-proto/xf86driproto-2.1.0
115 >=x11-proto/dri2proto-2.1
116 >=x11-libs/libdrm-2.3.0
117 )"
118
119 PDEPEND="xorg? ( >=x11-base/xorg-drivers-$(get_version_component_range 1-2) )"
120
121 EPATCH_FORCE="yes"
122 EPATCH_SUFFIX="patch"
123
124 # These have been sent upstream
125 UPSTREAMED_PATCHES=(
126 "${WORKDIR}/patches/"
127 # Fix for bug #304067
128 "${FILESDIR}/1.7.5.902-fix-tslib-1.0-check.patch"
129 "${FILESDIR}"/${PN}-1.8-nouveau-default.patch
130 )
131
132 PATCHES=(
133 "${UPSTREAMED_PATCHES[@]}"
134 )
135
136 pkg_setup() {
137 use minimal || ensure_a_server_is_building
138
139 # SDL only available in kdrive build
140 if use kdrive && use sdl; then
141 conf_opts="${conf_opts} --enable-xsdl"
142 else
143 conf_opts="${conf_opts} --disable-xsdl"
144 fi
145
146 # localstatedir is used for the log location; we need to override the default
147 # from ebuild.sh
148 # sysconfdir is used for the xorg.conf location; same applies
149 # --enable-install-setuid needed because sparcs default off
150 CONFIGURE_OPTIONS="
151 $(use_enable ipv6)
152 $(use_enable dmx)
153 $(use_enable kdrive)
154 $(use_enable tslib)
155 $(use_enable tslib xcalibrate)
156 $(use_enable !minimal xvfb)
157 $(use_enable !minimal xnest)
158 $(use_enable !minimal record)
159 $(use_enable !minimal xfree86-utils)
160 $(use_enable !minimal install-libxf86config)
161 $(use_enable !minimal dri)
162 $(use_enable !minimal dri2)
163 $(use_enable !minimal glx)
164 $(use_enable xorg)
165 $(use_enable nptl glx-tls)
166 $(use_enable hal config-hal)
167 --sysconfdir=/etc/X11
168 --localstatedir=/var
169 --enable-install-setuid
170 --with-fontdir=/usr/share/fonts
171 --with-xkb-output=/var/lib/xkb
172 --without-dtrace
173 ${conf_opts}"
174
175 # (#121394) Causes window corruption
176 filter-flags -fweb
177
178 # Incompatible with GCC 3.x SSP on x86, bug #244352
179 if use x86 ; then
180 if [[ $(gcc-major-version) -lt 4 ]]; then
181 filter-flags -fstack-protector
182 fi
183 fi
184
185 # Incompatible with GCC 3.x CPP, bug #314615
186 if [[ $(gcc-major-version) -lt 4 ]]; then
187 ewarn "GCC 3.x C preprocessor may cause build failures. Use GCC 4.x"
188 ewarn "or set CPP=cpp-4.3.4 (replace with the actual installed version)"
189 fi
190
191 OLD_IMPLEM="$(eselect opengl show)"
192 eselect opengl set ${OPENGL_DIR}
193 }
194
195 src_install() {
196 x-modular_src_install
197
198 dynamic_libgl_install
199
200 server_based_install
201
202 if ! use minimal && use xorg; then
203 # Install xorg.conf.example (see bugs #151421 and #151670)
204 insinto /etc/X11
205 doins hw/xfree86/xorg.conf.example \
206 || die "couldn't install xorg.conf.example"
207 fi
208 }
209
210 pkg_postinst() {
211 switch_opengl_implem
212
213 echo
214 ewarn "You must rebuild all drivers if upgrading from xorg-server 1.6"
215 ewarn "or earlier, because the ABI changed. If you cannot start X because"
216 ewarn "of module version mismatch errors, this is your problem."
217
218 echo
219 ewarn "You can generate a list of all installed packages in the x11-drivers"
220 ewarn "category using this command:"
221 ewarn "emerge portage-utils; qlist -I -C x11-drivers/"
222
223 ebeep 5
224 epause 10
225 }
226
227 pkg_postrm() {
228 # Get rid of module dir to ensure opengl-update works properly
229 if ! has_version x11-base/xorg-server; then
230 if [[ -e ${ROOT}/usr/$(get_libdir)/xorg/modules ]]; then
231 rm -rf "${ROOT}"/usr/$(get_libdir)/xorg/modules
232 fi
233 fi
234 }
235
236 dynamic_libgl_install() {
237 # next section is to setup the dynamic libGL stuff
238 ebegin "Moving GL files for dynamic switching"
239 dodir /usr/$(get_libdir)/opengl/${OPENGL_DIR}/extensions
240 local x=""
241 for x in "${D}"/usr/$(get_libdir)/xorg/modules/extensions/lib{glx,dri,dri2}*; do
242 if [ -f ${x} -o -L ${x} ]; then
243 mv -f ${x} "${D}"/usr/$(get_libdir)/opengl/${OPENGL_DIR}/extensions
244 fi
245 done
246 eend 0
247 }
248
249 server_based_install() {
250 if ! use xorg; then
251 rm "${D}"/usr/share/man/man1/Xserver.1x \
252 "${D}"/usr/$(get_libdir)/xserver/SecurityPolicy \
253 "${D}"/usr/$(get_libdir)/pkgconfig/xorg-server.pc \
254 "${D}"/usr/share/man/man1/Xserver.1x
255 fi
256 }
257
258 switch_opengl_implem() {
259 # Switch to the xorg implementation.
260 # Use new opengl-update that will not reset user selected
261 # OpenGL interface ...
262 echo
263 eselect opengl set ${OLD_IMPLEM}
264 }
265
266 ensure_a_server_is_building() {
267 for server in ${IUSE_SERVERS}; do
268 use ${server} && return;
269 done
270 eerror "You need to specify at least one server to build."
271 eerror "Valid servers are: ${IUSE_SERVERS}."
272 die "No servers were specified to build."
273 }

  ViewVC Help
Powered by ViewVC 1.1.20